unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, unit3, unit4, Registry, messages, printers,
  Dialogs, ComCtrls, jpeg, TabNotBk, Graphics, ExtCtrls, StdCtrls, ExtDlgs, Buttons, unit5;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SaveDialog1: TSaveDialog;
    Button1: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    ProgressBar1: TProgressBar;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    GroupBox2: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    TabControl1: TTabControl;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    CheckBox1: TCheckBox;
    Label7: TLabel;
    OpenPictureDialog1: TOpenPictureDialog;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    CheckBox4: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox2: TCheckBox;
    GroupBox3: TGroupBox;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    CheckBox5: TCheckBox;
    GroupBox4: TGroupBox;
    Label6: TLabel;
    Edit3: TEdit;
    UpDown1: TUpDown;
    Label5: TLabel;
    Edit7: TEdit;
    Label14: TLabel;
    UpDown2: TUpDown;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure RadioButton5Click(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure Label7Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Edit4Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure Edit3Change(Sender: TObject);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure Edit7Change(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
   public
    INIReg: TRegInifile;
    NowSelected:integer;//      
    procedure DrawVish;
    procedure DrawKey;
    procedure Calculate;
    procedure OptimizeColors;
    procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure SetRealSize;
    procedure Save2File(flag:byte);
    procedure Printp(flag: byte);
  end;

var
  Form1: TForm1;
  Symbols, Znak, Key, Stretch: TBitmap;//  ,        
  r1: trect; //     
  VertNum, HorNum, ALLOttenkov, Ottenkov, MaxOttenkov: integer;
  KrestHeight, KrestWidth, Proportion: extended;
  Vish: array of array of Cardinal;
  Origin: array of array of trgb;
  num:array [1..460] of Int64;//    
  quont: array of cardinal; //           
  calc:array of array of extended; //     
  resAr: array of cardinal;//       (   )
  ppic:array of PARGB;  //      

implementation

{$R *.dfm}

procedure Tform1.Calculate;
begin
 if radiobutton1.Checked then begin
  edit1.Text:=inttostr(Doedin(strtoint(edit2.text)/proportion));
  edit6.Text:=inttostr(Doedin(strtoint(edit2.Text)/strtofloat(edit3.Text)));
  edit5.Text:=inttostr(Doedin(strtoint(edit1.Text)/strtofloat(edit7.Text)));
 end;
 if radiobutton2.Checked then begin
  edit2.Text:=inttostr(Doedin(strtoint(edit1.text)*proportion));
  edit6.Text:=inttostr(Doedin(strtoint(edit2.Text)/strtofloat(edit3.Text)));
  edit5.Text:=inttostr(Doedin(strtoint(edit1.Text)/strtofloat(edit7.Text)));
 end;
 if radiobutton3.Checked then begin
  edit2.Text:=inttostr(Doedin(strtoint(edit6.text)*strtofloat(edit3.Text)));
  edit1.Text:=inttostr(Doedin(strtoint(edit2.text)/proportion));
  edit5.Text:=inttostr(Doedin(strtoint(edit1.Text)/strtofloat(edit7.Text)));
 end;
 if radiobutton4.Checked then begin
  edit1.Text:=inttostr(Doedin(strtoint(edit5.text)*strtofloat(edit7.Text)));
  edit2.Text:=inttostr(Doedin(strtoint(edit1.text)*proportion));
  edit6.Text:=inttostr(Doedin(strtoint(edit2.Text)/strtofloat(edit3.Text)));
 end;
 VertNum:=strtoint(edit6.Text);
 HorNum :=strtoint(edit5.Text);
 KrestWidth:=strtofloat(edit3.Text);
 KrestHeight:=strtofloat(edit7.Text);
 label10.Caption:=': '+pointednumber(inttostr(hornum*vertnum));
 label11.Caption:=': '+pointednumber(inttostr(doedin(vertnum*KrestWidth)))+' ';
 label12.Caption:=': '+pointednumber(inttostr(doedin(hornum*KrestHeight)))+' ';
end;

procedure TForm1.SetRealSize;
 var ScreenXpixel,ScreenXmm:integer;
 p:extended;
begin
 if (form1.Tag=1)and(TabControl1.TabIndex>0) then begin image1.Width:=0; image1.Height:=0; exit; end;
 ScreenXpixel:=GetSystemMetrics(SM_CXSCREEN);
 ScreenXmm:=GetDeviceCaps(getdc(0),HORZSIZE);
 p:=ScreenXPixel/ScreenXmm;
 image1.Width:=doedin(vertnum*KrestWidth*p);
 image1.Height:=doedin(image1.Width/proportion);
end;

procedure Tform1.DrawVish;
 var i,j,X,Y,Nu:integer;
 rect:trect; //  
begin
  image3.Picture.Bitmap.PixelFormat:=pf24bit;
  image3.Width:=VertNum*9;
  image3.Height:=VertNum*9;

  image3.Picture.Bitmap.Width:=VertNum*9; //100       
  image3.Picture.Bitmap.Height:=HorNum*9;
  image4.Picture.Bitmap.PixelFormat:=pf24bit;// 24  
  if checkbox2.Checked then begin
   image4.Picture.Bitmap.Width:=1+VertNum*19+(VertNum div 10)+(VertNum div 5);
   image4.Picture.Bitmap.Height:=1+HorNum*19+(HorNum div 10)+(HorNum div 5);
  end else begin
   image4.Picture.Bitmap.Width:=VertNum*18;
   image4.Picture.Bitmap.Height:=HorNum*18;
  end;

  rect.Left:=0;
  rect.Top:=0;
  rect.Bottom:=image4.Picture.Bitmap.Height;
  rect.Right:=image4.Picture.Bitmap.Width;
  image4.Canvas.Brush.Color:=0;//16776960; // 
  image4.Canvas.FillRect(rect);
  
  progressbar1.Max:=VertNum;
  ppic:=nil;   //     
  setlength(ppic,image3.Picture.Bitmap.Height);
  for i:=0 to High(ppic) do ppic[i]:=image3.Picture.Bitmap.scanline[i];

  for i:=0 to VertNum-1 do begin
   for j:=0 to HorNum-1 do begin
     ////////////  ////////////
    if checkbox2.Checked then begin  //      
     rect.Left:=(i div 10)+(i div 5)+i*19+1; // 
     rect.Top:=(j div 10)+(j div 5)+j*19+1;
    end else begin  //   
     rect.Left:=i*18;
     rect.Top:=j*18;
    end;
     rect.Bottom:=rect.Top+18;
     rect.Right:=rect.Left+18;

     if (checkbox5.Checked) or (checkbox5.Enabled=false) then
      Znak.Canvas.Brush.Color:=Vish[i][j] //    
     else
      Znak.Canvas.Brush.Color:=16777215; //    
     Znak.Canvas.FillRect(r1);

     if checkbox3.Checked then begin //  
      Nu:=0; //        !
      while Vish[i][j]<>ResAr[Nu] do inc(Nu);

      if nu>120 then nu:=120;
      Y:=nu div 10;
      X:=(nu - Y*10)*18;
      Y:=Y*18;
      //        
      if Round(0.30*GetRValue(Znak.Canvas.Brush.Color)+
               0.59*GetGValue(Znak.Canvas.Brush.Color)+
               0.11*GetBValue(Znak.Canvas.Brush.Color))<195 then
            BitBlt(Znak.Canvas.Handle,0,0,17,17,Symbols.Canvas.Handle,X,Y,SRCINVERT+DSTINVERT)
       else BitBlt(Znak.Canvas.Handle,0,0,17,17,Symbols.Canvas.Handle,X,Y,SRCAND);
     end else if checkbox4.Checked then begin
        BitBlt(Znak.Canvas.Handle,0,0,17,17,Stretch.Canvas.Handle,0,0,SRCAND);
     end;

     image4.Canvas.CopyRect(rect,Znak.Canvas,r1); //    
    ///////////////////  /////////////
    for x:=0 to 8 do    //   
     for y:=0 to 8 do begin
      ppic[j*9+y,i*9+x].r:=Origin[i][j].r;
      ppic[j*9+y,i*9+x].g:=Origin[i][j].g;
      ppic[j*9+y,i*9+x].b:=Origin[i][j].b;
     end; 
  end;
  progressbar1.StepIt;
  end;
  SetRealSize;
  progressbar1.Max:=0;
  progressbar1.StepIt;
  FormResize(nil);
  TabControl1Change(nil);
end;

procedure TForm1.DrawKey;
 var i,j,X,Y,mk:integer;
 rect:trect;
begin
 key.PixelFormat:=pf24bit;// 24  
 Key.Width:=633;
 Key.Height:=895;
 mk:=40;//    

 rect.Left:=0;    //   
 rect.Top:=0;
 rect.Right:=Key.Width;
 rect.Bottom:=Key.Height;        
 Key.Canvas.Brush.Color:=16777215; // 
 Key.Canvas.FillRect(rect);

 for i:=0 to length(resAr)-1 do begin
  j:=i;
  if j>120 then j:=120;
  Y:=j div 10;
  X:=(j - Y*10)*18;
  Y:=Y*18;

  if checkbox5.Checked or (checkbox5.Enabled=false) then
   Znak.Canvas.Brush.Color:=resAr[i] //    
  else
   Znak.Canvas.Brush.Color:=16777215; //    
  Znak.Canvas.FillRect(r1);

  if checkbox3.Checked then //   ,       
  if Round(0.30*getRvalue(Znak.Canvas.Brush.Color)+0.59*getGvalue(Znak.Canvas.Brush.Color)+0.11*GetBValue(Znak.Canvas.Brush.Color))<195 then
        BitBlt(Znak.Canvas.Handle,0,0,17,17,Symbols.Canvas.Handle,X,Y,SRCINVERT+DSTINVERT)
   else BitBlt(Znak.Canvas.Handle,0,0,17,17,Symbols.Canvas.Handle,X,Y,SRCAND);

  rect.Left:=(i div mk);
  rect.Top:=(i-rect.Left*mk)*22{ }+10{   };
  rect.Left:=rect.Left*123{ }+20{   };
  rect.Right:=rect.Left+18;
  rect.Bottom:=rect.Top+18;

  j:=1; //        !
  while DMC[j].Color<>ResAr[i] do inc(j);

  Key.Canvas.CopyRect(rect,Znak.Canvas,r1); //    
  rect.TopLeft.X:=rect.TopLeft.X+24;
  rect.TopLeft.Y:=rect.TopLeft.Y+8;
  Key.Canvas.PenPos:=rect.TopLeft;
  Key.Canvas.LineTo(Key.Canvas.PenPos.x+7,Key.Canvas.PenPos.y);
  Key.Canvas.TextOut(Key.Canvas.PenPos.x+4,Key.Canvas.PenPos.y-6,DMC[j].Number);
 end;
 FormResize(nil);
 TabControl1Change(nil);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 INIReg:=TRegInifile.Create;
 INIReg.WriteString(RegKey,'SaveDir',savedialog1.InitialDir);
 INIReg.WriteString(RegKey,'OpenDir',OpenPictureDialog1.InitialDir);
 INIReg.WriteBool(RegKey,'Stretch',radiobutton5.checked);
 INIReg.WriteString(RegKey,'MulineNum',edit4.Text);
 INIReg.WriteInteger(RegKey,'KrestikWidth',updown1.Position);
 INIReg.WriteInteger(RegKey,'KrestikHeight',updown2.Position);

 INIReg.WriteInteger(RegKey,'RadioButton',Nowselected);

 INIReg.WriteString(RegKey,'VishWidth',edit2.Text);
 INIReg.WriteString(RegKey,'VishHeight',edit1.Text);
 INIReg.WriteString(RegKey,'Vertnum',edit6.Text);
 INIReg.WriteString(RegKey,'Hornum',edit5.Text);
 INIReg.WriteBool(RegKey,'Limit',CheckBox1.checked);
 INIReg.WriteBool(RegKey,'Setka',CheckBox2.checked);
 INIReg.WriteBool(RegKey,'Znaki',CheckBox3.checked);
 INIReg.WriteBool(RegKey,'Real',CheckBox4.checked);
 INIReg.WriteBool(RegKey,'Color',CheckBox5.checked);
 INIReg.WriteInteger(RegKey,'PrinterIndex',unit5.PrinterItem);

 if form1.WindowState=wsmaximized then
  INIReg.WriteBool(RegKey,'WinState',true) else begin
  INIReg.WriteInteger(RegKey,'WinTop',form1.Top);
  INIReg.WriteInteger(RegKey,'WinLeft',form1.Left);
  INIReg.WriteInteger(RegKey,'WinWidth',form1.Width);
  INIReg.WriteInteger(RegKey,'WinHeight',form1.Height);
  INIReg.WriteBool(RegKey,'WinState',false);
 end;
 INIReg.CloseKey;
 INIReg.Free;

 Symbols.Free;
 Znak.Free;
 Key.Free;
 Stretch.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
 var i:integer;
begin
 Key:=TBitmap.Create;//   
 Stretch:=TBitmap.Create;// 
 Symbols:=TBitmap.Create; //    
 Symbols.Height:=216;
 Symbols.Width:=180;
 Symbols.LoadFromResourceName(hinstance,'SYMBOLS');
 stretch.Height:=18;
 stretch.Width:=18;
 stretch.LoadFromResourceName(hinstance,'STITCH');
 Znak:=TBitmap.Create;
 Znak.Width:=18;//     
 Znak.Height:=18;
 r1.Left:=0;  //      
 r1.Top:=0;
 r1.Right:=18; //        
 r1.Bottom:=18;

 RadioButton1.Hint:='   ,'+#13+#10+'   .';
 RadioButton2.Hint:=RadioButton1.Hint;
 RadioButton3.Hint:=RadioButton1.Hint;
 RadioButton4.Hint:=RadioButton1.Hint;

 TabControl1.DoubleBuffered:=true;
 for i:=1 to 460 do begin    //     
  DMC[i].Number:=dmc2001[(i-1)*4+1]; //  
  DMC[i].R:=strtoint(dmc2001[(i-1)*4+2]);         
  DMC[i].G:=strtoint(dmc2001[(i-1)*4+3]);
  DMC[i].B:=strtoint(dmc2001[(i-1)*4+4]);
  DMC[i].Color:=(DMC[i].R)+((DMC[i].G) shl 8)+((DMC[i].B) shl 16);
 end;                       
 form1.Tag:=0;
 proportion:=1;
 RadioButton1Click(nil);
 Label7.Caption:=''+#13+#10+' ';
 INIReg:=TRegInifile.Create;
 edit4.Text:=INIReg.ReadString(RegKey,'MulineNum','30');
 updown1.Position:=INIReg.ReadInteger(RegKey,'KrestikWidth',170);
 edit3.Text:=floattostr(updown1.position*0.01);
 updown2.Position:=INIReg.ReadInteger(RegKey,'KrestikHeight',170);
 edit7.Text:=floattostr(updown2.position*0.01);
  
 form1.Top:=INIReg.ReadInteger(RegKey,'WinTop',80);
 form1.Left:=INIReg.ReadInteger(RegKey,'WinLeft',80);
 form1.Width:=INIReg.ReadInteger(RegKey,'WinWidth',700);
 form1.Height:=INIReg.ReadInteger(RegKey,'WinHeight',570);
 unit5.PrinterItem:=INIReg.ReadInteger(RegKey,'PrinterIndex',-1);

 Nowselected:=INIReg.ReadInteger(RegKey,'RadioButton',1);
 case Nowselected of
  1:radiobutton1.Checked:=true;
  2:radiobutton2.Checked:=true;
  3:radiobutton3.Checked:=true;
  4:radiobutton4.Checked:=true;
 end;
 edit2.Text:=INIReg.ReadString(RegKey,'VishWidth','150');
 edit1.Text:=INIReg.ReadString(RegKey,'VishHeight','150');
 edit6.Text:=INIReg.ReadString(RegKey,'Vertnum','150');
 edit5.Text:=INIReg.ReadString(RegKey,'Hornum','150');
 Calculate;

 radiobutton5.checked:=INIReg.ReadBool(RegKey,'Stretch',false);
 radiobutton6.checked:=not(radiobutton5.checked);
 savedialog1.InitialDir:=INIReg.ReadString(RegKey,'SaveDir','');
 OpenPictureDialog1.InitialDir:=INIReg.ReadString(RegKey,'OpenDir','');
 CheckBox1.checked:= INIReg.ReadBool(RegKey,'Limit',True);
 CheckBox2.checked:= INIReg.ReadBool(RegKey,'Setka',True);
 CheckBox3.checked:= INIReg.ReadBool(RegKey,'Znaki',True);
 CheckBox4.checked:= INIReg.ReadBool(RegKey,'Real',True);
 CheckBox5.checked:= INIReg.ReadBool(RegKey,'Color',True);
 checkbox5.Enabled:=checkbox3.Checked;
 if INIReg.ReadBool(RegKey,'WinState',false) then form1.WindowState:=wsmaximized;
 INIReg.CloseKey;
 INIReg.Free;
 image1.Width:=0;
 image1.Height:=0;
 scrollbox1.DoubleBuffered:=true;
end;

procedure TForm1.OptimizeColors;
 var i,j,n,k,m,z,i1,j1:integer;
 min,tem:extended;
 res:array of rep;
 label end1;
begin
 i1:=0;
 j1:=0;
 ///  
 k:=ALLottenkov-maxottenkov; //     !
 setlength(res,k);
 m:=ALLottenkov-1;//       

 while num[quont[m]]<6 do begin //   (      )
  dec(m);
  if (m<0) or ((m+1)=maxottenkov) then break;
 end;

 for i:=m+1 to (ALLottenkov-1) do begin
  min:=1e6;
  res[i-m-1].NumColor:=quont[i];
  for n:=0 to m do begin
   tem:=GetDistance(DMC[quont[i]].Color,DMC[quont[n]].Color);
   if tem<min then begin
    res[i-m-1].NumAnalog:=quont[n];
    min:=tem;
   end;
  end;

  for n:=0 to allottenkov-1 do begin//    
   calc[i,n]:=0;
   calc[n,i]:=0;
  end;
  quont[i]:=0; // 
 end;
 if (m+1)=maxottenkov then goto end1;
//////////////////  ///////////////
 z:=ALLottenkov-m-2; //      -1
 repeat begin
  inc(z);
  min:=1e6;
  for i:=0 to allottenkov-1 do
   for j:=0 to allottenkov-1 do
    if (calc[i,j]>0) and (calc[i,j]<min) then begin
     i1:=i;
     j1:=j;
     min:=calc[i,j];
    end;

    if num[quont[i1]]<num[quont[j1]] then begin //   
     for n:=0 to allottenkov-1 do begin//    
      calc[i1,n]:=0;
      calc[n,i1]:=0;
     end;
     res[z].NumColor:=quont[i1];
    end else begin
     for n:=0 to allottenkov-1 do begin//    
      calc[j1,n]:=0;
      calc[n,j1]:=0;
     end;
     res[z].NumColor:=quont[j1];
    end;
 end until z=k-1;

 for i:=(ALLottenkov-m-1) to k-1 do begin //     
  min:=1e6;
  for j:=0 to allottenkov-1 do  //  calc
   if calc[j,0]<>0 then begin //    
    tem:=GetDistance(DMC[quont[j]].Color,DMC[res[i].NumColor].Color);
    if tem<min then begin
     res[i].NumAnalog:=quont[j];
     min:=tem;
    end;
   end;
 end;
////////////////end   ////////
 end1:

 for i:=0 to VertNum-1 do
  for j:=0 to HorNum-1 do 
   for n:=0 to k-1 do
    if Vish[i][j]=DMC[res[n].NumColor].Color then
      Vish[i][j]:=DMC[res[n].NumAnalog].Color;

   ottenkov:=maxottenkov;
end;

procedure TForm1.Button1Click(Sender: TObject);
 var i,j,x,y,r,g,b,k,i1,i2:integer;
 trig:boolean;
 px,py,plo,UsePlo,r2,g2,b2,DX,DY:extended;
 LV,PV,PN,LN:Ver; //LV - Leviy Verhniy i t.d.
begin
  if form1.Tag=0 then begin showmessage('   '); exit; end;
  if (HorNum<2) or (VertNum<2) then begin showmessage('   '+#13+#10+'   .  .'); exit; end;

  MaxOttenkov:=strtoint(edit4.Text);
  if (MaxOttenkov<2) and CheckBox1.Checked then begin showmessage('     1'); exit; end;
  ALLOttenkov:=0;
  Ottenkov:=0;
  Calc:=nil;
  Vish:=nil;
  Origin:=nil;
  Quont:=nil;
  setlength(vish, VertNum, HorNum);
  setlength(Origin, VertNum, HorNum);
  for i:=1 to 460 do num[i]:=0;  //  

  progressbar1.Max:=vertnum;
  button1.Enabled:=false;
  ppic:=nil;
  setlength(ppic,image2.Picture.Bitmap.Height);
  for i:=0 to High(ppic) do ppic[i]:=image2.Picture.Bitmap.scanline[i];

  DX:=(image2.Picture.Bitmap.Width-1e-7)/VertNum;  //    (         DoMax  ,  1e-7 !!!!)
  DY:=(image2.Picture.Bitmap.Height-1e-7)/HorNum; //  ,       
  for i:=0 to VertNum-1 do begin //  
   LV.x:=i*DX;   //      
   PV.x:=LV.x+DX;
   LV.Ox:=trunc(LV.x); //    ,    
   PV.Ox:=domax(PV.x)-1;    //   domax ..     0
   LV.Dx:=frac(LV.x);//    , LV  PN    
   PN.Dx:=1-frac(PV.x);
   for j:=0 to HorNum-1 do begin //  
    LV.y:=j*DY;   //      
    LN.y:=LV.y+DY;
    LV.Oy:=trunc(LV.y); //    ,    
    LN.Oy:=domax(LN.y)-1;
    LV.Dy:=frac(LV.y);
    PN.Dy:=1-frac(LN.y);
    r2:=0;
    g2:=0;
    b2:=0;
    for x:=LV.Ox to PV.Ox do
     for y:=LV.Oy to LN.Oy do begin
      px:=1; //        
      py:=1;
      if x=LV.Ox then px:=px-LV.Dx;
      if x=PV.Ox then px:=px-PN.Dx;
      if y=LV.Oy then py:=py-LV.Dy;
      if y=LN.Oy then py:=py-PN.Dy;
      UsePlo:=px*py;     //  
      r2:=r2+ppic[y,x].r*UsePlo;
      g2:=g2+ppic[y,x].g*UsePlo;
      b2:=b2+ppic[y,x].b*UsePlo;
     end;
    plo:=DX*DY;
    r:=doedin(r2/plo);
    g:=doedin(g2/plo);
    b:=doedin(b2/plo);
    Origin[i][j].r:=r;
    Origin[i][j].g:=g;
    Origin[i][j].b:=b;
    Vish[i][j]:=Nearest(r,g,b);
   end;
   progressbar1.StepIt;
  end;
//////////////end///////////////
 progressbar1.Max:=0;
 progressbar1.StepIt;

 for i:=1 to 460 do if num[i]>0 then begin //      
  inc(ALLottenkov);
  setlength(quont, ALLottenkov);
  quont[ALLottenkov-1]:=i;
 end;

 if checkbox1.Checked and (maxottenkov<ALLottenkov) then begin // - 
   repeat  //    
   trig:=true;
   for i:=0 to ALLottenkov-2 do begin
    i1:=quont[i];
    i2:=quont[i+1];
    if num[i1]<num[i2] then
     begin
      trig:=false;
      quont[i]:=i2;
      quont[i+1]:=i1;
     end;
   end;
  until trig;

  setlength(Calc, ALLottenkov, ALLottenkov);
  for i:=0 to ALLottenkov-1 do begin//     
   for j:=0 to ALLottenkov-1 do
    if i<>j then
     Calc[i,j]:=GetDistance(DMC[quont[i]].Color,DMC[quont[j]].Color);
  end;

 OptimizeColors; //!

 end else Ottenkov:=ALLottenkov;;

 label13.Caption:=': '+inttostr(ottenkov)+' ( '+inttostr(ALLOttenkov)+')';

 setlength(resAr,1);//      ,    
 ResAr[0]:=Vish[0][0];//    
 for i:=0 to VertNum-1 do
 for j:=0 to HorNum-1 do begin
  trig:=true;
  for k:=0 to length(resAr)-1 do begin
   if Vish[i][j]=resAr[k] then trig:=false;
  end;
  if trig then begin
   setlength(resAr,length(resAr)+1);
   resAr[length(resAr)-1]:=Vish[i][j];
  end;
 end;

 if ottenkov>120 then showmessage(' ,  .'+#10#13+'     120.');
 DrawVish;
 DrawKey;
 form1.Tag:=2;
 TabControl1.TabIndex:=2;
 TabControl1Change(nil);

 speedbutton2.Enabled:=true;
 speedbutton3.Enabled:=true;
 speedbutton5.Enabled:=true;
 speedbutton4.Enabled:=true;
 button1.Enabled:=true;
end;

procedure TForm1.FormResize(Sender: TObject);
 var x,y:integer;
 p:extended;
begin
 if (radiobutton6.Checked)or(TabControl1.TabIndex=3) then begin   // 1:1
  if (form1.Tag>0)and(TabControl1.TabIndex<3) then SetRealSize;

  Scrollbox1.HorzScrollBar.Position:=0;
  Scrollbox1.VertScrollBar.Position:=0;
  application.ProcessMessages;

  y:=(scrollbox1.ClientHeight-image1.Height) div 2;
  x:=(scrollbox1.ClientWidth-image1.Width) div 2;

  if y>1 then image1.Top:=y else image1.Top:=0;
  if x>1 then image1.Left:=x else image1.Left:=0;

  x:=Scrollbox1.ClientWidth+(image1.Width-Scrollbox1.ClientWidth);
  y:=Scrollbox1.ClientHeight+(image1.Height-Scrollbox1.ClientHeight);

  Scrollbox1.HorzScrollBar.Range:=x;
  Scrollbox1.VertScrollBar.Range:=y;

  y:=(scrollbox1.ClientHeight-image1.Height) div 2;
  x:=(scrollbox1.ClientWidth-image1.Width) div 2;

  if y>1 then image1.Top:=y else image1.Top:=0;
  if x>1 then image1.Left:=x else image1.Left:=0;
 end else begin                                   //  
  Scrollbox1.HorzScrollBar.Position:=0;
  Scrollbox1.VertScrollBar.Position:=0; 
  Scrollbox1.HorzScrollBar.Range:=0;
  Scrollbox1.VertScrollBar.Range:=0;
  application.ProcessMessages;
   
  p:=scrollbox1.Width/scrollbox1.Height;

  if p<proportion then begin
   image1.Width:=scrollbox1.ClientWidth;
   image1.Height:=doedin(image1.Width/proportion);
  end else begin
   image1.Height:=scrollbox1.ClientHeight;
   image1.Width:=doedin(image1.Height*proportion);
  end;

  image1.Top:=(scrollbox1.ClientHeight-image1.Height) div 2;
  image1.Left:=(scrollbox1.ClientWidth-image1.Width) div 2;
 end;
 image1.Visible:=true;
 application.ProcessMessages;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
 edit1.Enabled:=false;
 edit2.Enabled:=false;
 edit5.Enabled:=false;
 edit6.Enabled:=false;
 if radiobutton1.Checked then begin edit2.Enabled:=true; nowselected:=1; end;
 if radiobutton2.Checked then begin edit1.Enabled:=true; nowselected:=2; end;
 if radiobutton3.Checked then begin edit6.Enabled:=true; nowselected:=3; end;
 if radiobutton4.Checked then begin edit5.Enabled:=true; nowselected:=4; end;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
 if ((byte(key)<48) and (byte(key)<>8)) or (byte(key)>57) then key:=#0;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
 if (edit2.Text<>'') and radiobutton1.Checked then begin
  Calculate;
  RadioButton5Click(nil);
 end;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
 if (edit1.Text<>'') and radiobutton2.Checked then begin
  Calculate;
  RadioButton5Click(nil);
 end; 
end;

procedure TForm1.Edit6Change(Sender: TObject);
begin
 if (edit6.Text<>'') and radiobutton3.Checked then begin
  Calculate;
  RadioButton5Click(nil);
 end;
end;

procedure TForm1.Edit5Change(Sender: TObject);
begin
 if (edit5.Text<>'') and radiobutton4.Checked then begin
  Calculate;
  RadioButton5Click(nil);  
 end;
end;

procedure TForm1.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
 Msg.MinMaxInfo^.ptMinTrackSize := Point(575, 571);
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
 edit3.Text:=floattostr(updown1.position*0.01);
 Calculate;
end;

procedure TForm1.RadioButton5Click(Sender: TObject);
begin
 Scrollbox1.HorzScrollBar.Position:=0;
 Scrollbox1.VertScrollBar.Position:=0;
 Scrollbox1.HorzScrollBar.Range:=0;
 Scrollbox1.VertScrollBar.Range:=0;
 FormResize(nil);
 application.ProcessMessages;
end;

procedure TForm1.TabControl1Change(Sender: TObject);
begin
 case TabControl1.TabIndex of
  0: image1.Picture:=image2.Picture; 
  1: image1.Picture:=image3.Picture; 
  2: image1.Picture:=image4.Picture; 
  3: begin
      image1.Width:=key.Width;
      image1.height:=key.height;
      image1.Picture.Bitmap.Width:=key.Width;
      image1.Picture.Bitmap.Height:=key.height;
      image1.Picture.Bitmap:=key;
     end; 
 end;
 FormResize(nil);
end;

procedure TForm1.Label7Click(Sender: TObject);
begin
 checkbox1.Checked:=not checkbox1.Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
 checkbox4.Enabled:=not(checkbox3.Checked);
 checkbox5.Enabled:=checkbox3.Checked;
 if form1.Tag<2 then exit;
 DrawVish;
 DrawKey;
end;

procedure TForm1.Edit4Click(Sender: TObject);
begin
 edit4.SelectAll;
end;

procedure TForm1.Save2File(flag: byte);
 var filname:string;
     MyJPEG : TJPEGImage;
begin
 if flag=0 then
 savedialog1.Title:=' '
 else savedialog1.Title:=' ';
 savedialog1.FileName:='';
 if savedialog1.Execute then begin
   if savedialog1.FilterIndex=1 then begin
    filname:=ChangeFileExt(savedialog1.FileName,'')+'.bmp';
    if FileExists(filname) then if
     messagebox(form1.Handle,pchar(' "'+Extractfilename(filname)+'"  .  ?'),'',MB_YESNO or MB_ICONQUESTION)=7 then begin
      if flag=0 then speedButton2Click(nil)
                else SpeedButton3Click(nil);
      exit;
     end;
    if flag=0 then image4.Picture.SaveToFile(filname)
              else key.SaveToFile(filname);
   end else begin
    filname:=ChangeFileExt(savedialog1.FileName,'')+'.jpg';
    if FileExists(filname) then if
     messagebox(form1.Handle,pchar(' "'+Extractfilename(filname)+'"  .  ?'),'',MB_YESNO or MB_ICONQUESTION)=7 then begin
      if flag=0 then speedButton2Click(nil)
                else SpeedButton3Click(nil);
      exit;
     end;
    MyJPEG := TJPEGImage.Create;
    try
     MyJPEG.CompressionQuality:=97;
     if flag=0 then MyJPEG.Assign(image1.Picture.Bitmap)
               else MyJPEG.Assign(key);
     MyJPEG.SaveToFile(filname);
    finally
     MyJPEG.Free;
    end;
   end;
 savedialog1.InitialDir:=ExtractFilePath(savedialog1.Filename);//   
 end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
 var ext:string;
     MyJPEG: TJPEGImage;
begin 
 if OpenPictureDialog1.Execute then begin
  ext:=ExtractFileExt(OpenPictureDialog1.FileName);
  ext:=LowerCase(ext);
  if ext='.bmp' then begin
   image2.Picture.LoadFromFile(OpenPictureDialog1.FileName);
  end else begin // 
   MyJPEG := TJPEGImage.Create;
   try
    MyJPEG.LoadFromFile(OpenPictureDialog1.FileName);
    image2.Picture.Bitmap.PixelFormat:=pf24bit;
    image2.Picture.Bitmap.Width:=MyJPEG.Width;
    image2.Picture.Bitmap.Height:=MyJPEG.Height;
    image2.Canvas.Draw(0,0,MyJPEG);
   finally
    MyJPEG.Free;
   end;
  end;
  form1.Tag:=1; // 
  Proportion:=image2.Picture.Bitmap.Width/image2.Picture.Bitmap.height;
  image1.Visible:=false;

  image2.Picture.Bitmap.PixelFormat:=pf24bit; //    
  image1.Picture:=image2.Picture;
  image1.Top:=0;
  image1.Left:=0;

  image3.Picture:=nil;
  image4.Picture:=nil;
  key.Width:=0;
  key.Height:=0;

  OpenPictureDialog1.InitialDir:=extractfilepath(OpenPictureDialog1.FileName);
  Caption:='    : '+OpenPictureDialog1.Filename;
  Calculate;
  SetRealsize;

  TabControl1.TabIndex:=0;
  TabControl1Change(nil);

  speedbutton2.Enabled:=false;
  speedbutton3.Enabled:=false;
  speedbutton4.Enabled:=false;
  speedbutton5.Enabled:=false;

  FormResize(self);
  label13.Caption:=': 0 ( 0)';
 end;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
 Save2File(1);
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
 Save2File(0);
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
 form5.Position:=poOwnerFormCenter;
 form5.Tag:=0;
 form5.Caption:=' ';
 form5.ShowModal;
 if form5.Tag=1 then Printp(1);
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
 form5.Position:=poOwnerFormCenter;
 form5.Tag:=0;
 form5.Caption:=' '; 
 form5.ShowModal;
 if form5.Tag=1 then Printp(0);
end;

procedure TForm1.Printp(flag: byte);
 var rect:trect;
 pro:extended;
begin
 pro:=image4.Picture.Bitmap.Width/image4.Picture.Bitmap.Height;
 printer.PrinterIndex:=form5.ComboBox1.ItemIndex;// 
 printer.Orientation:=poPortrait;
 rect.Left:=10;
 rect.Top:=10;
 rect.Bottom:=printer.PageHeight-20;
 rect.Right:=printer.PageWidth-20;
 if flag=0 then begin  // 
  if pro>1 then begin // landscape
   printer.Orientation:=poLandscape;
   rect.Bottom:=printer.PageHeight-20;
   rect.Right:=printer.PageWidth-20;
   if pro>(297/210) then
    rect.Bottom:=round(rect.Right/pro)
   else
    rect.Right:=round(rect.Bottom*pro);
    
  end else begin   //photo
    if pro>(210/297) then
     rect.Bottom:=round(rect.Right/pro)
    else
     rect.Right:=round(rect.Bottom*pro);
  end;

  printer.BeginDoc;
  printer.Canvas.StretchDraw(rect,image4.Picture.Graphic);
  printer.EndDoc;
 end else begin   // 
  printer.BeginDoc;
  printer.Canvas.StretchDraw(rect,key);
  printer.EndDoc;
 end;
end;

procedure TForm1.UpDown2Click(Sender: TObject; Button: TUDBtnType);
begin
 edit7.Text:=floattostr(updown2.position*0.01);
 Calculate;
end;

procedure TForm1.Edit3Change(Sender: TObject);
 var i:integer;
begin
 if Edit3.Text='' then Edit3.Text:='0,01';
 i:=doedin(strtofloat(edit3.text)*100);
 if i>1000 then i:=1000;
 if i<1 then i:=1;
 Edit3.Text:=floattostr(i*0.01);
 UpDown1.Position:=i;
 Calculate;
 RadioButton5Click(nil);
end;

procedure TForm1.Edit7Change(Sender: TObject);
 var i:integer;
begin
 if Edit7.Text='' then Edit7.Text:='0,01';
 i:=doedin(strtofloat(Edit7.Text)*100);
 if i>1000 then i:=1000;
 if i<1  then i:=1;
 Edit7.Text:=floattostr(i*0.01);
 UpDown2.Position:=i;
 Calculate;
 RadioButton5Click(nil);
end;

procedure TForm1.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
 if ((byte(key)<48) and (byte(key)<>8) and (byte(key)<>44)) or (byte(key)>57) then key:=#0;
 if (byte(key)=44) and (pos(',',tedit(sender).Text)>0) then key:=#0;;
end;

procedure TForm1.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var mp:TPoint;
begin
 mp:=ScreenToClient(MousePos);
 if (mp.X>ScrollBox1.Left)and(mp.X<ScrollBox1.Left+ScrollBox1.Width) and
    (mp.Y>ScrollBox1.Top)and(mp.Y<ScrollBox1.Top+ScrollBox1.Height) then
 ScrollBox1.VertScrollBar.Position:=
 ScrollBox1.VertScrollBar.Position-15*WheelDelta div abs(WheelDelta);
end;

end.
