unit Unit3;

interface

uses sysutils, dialogs, unit4;

type
 trgb = record  //,      ,     
  b,g,r: byte;
 end;

 ARGB = array [0..0] of TRGB;
 PARGB = ^ARGB;

 Item = record
  R:byte;
  G:byte;
  B:byte;
  Color:cardinal;
  Number:string;
 end;

 Rep = record
  NumColor:cardinal;
  NumAnalog:cardinal;
 end;

 Ver = record //      
  x:extended; // 
  y:extended;
  Ox:integer; //     
  Oy:integer;
  Dx:extended; //    ,     
  Dy:extended;
 end;

function Doedin(x:extended):integer;
function DoMax(x:extended):integer;
function PointedNumber(buf:string):string;
function Nearest(r,g,b:integer):integer; 
function GetDistance(x,y:cardinal):extended;

var DMC: array [1..460] of item;

implementation

uses unit1;

function Doedin(x:extended):integer;
 var z:extended; y:integer;
begin
 z:=trunc(frac(x)*10);
 y:=trunc(x);
 if z<0.001 then z:=0;
 if z>4 then result:=y+1 else result:=y;
end;

function DoMax(x:extended):integer;
begin
 result:=trunc(x);
 if frac(x)>1e-7 then inc(result); //,   !!!            
end;

function PointedNumber(buf:string):string;//    
 var x:word;
begin
 result:=buf;
 x:=length(result);
 while x>3 do begin
  dec(x,2);
  insert('.',result,x);
  dec(x);
 end;
end;

function GetDistance(x,y:cardinal):extended;
begin
 Result:=sqrt(sqr(byte(x shr 16)-byte(y shr 16))+sqr(byte(x shr 8)-byte(y shr 8))+sqr(byte(x)-byte(y)));
end;

function Nearest(r,g,b:integer):integer; //  DMC     
 var i,j:integer;
 min,stA:extended;
begin
 j:=0;
 min:=1e6;
 for i:=1 to 460 do begin
  stA:=sqrt(sqr(b-DMC[i].B)+sqr(g-DMC[i].G)+sqr(r-DMC[i].R));//       
  if sta<min then begin
   j:=i;
   min:=sta;
  end;                    
 end;
 inc(num[j]); //    
 result:=(DMC[j].R)+((DMC[j].G) shl 8)+((DMC[j].B) shl 16);
end;

end.
